"""
Django settings for addwine project.

Generated by 'django-admin startproject' using Django 1.11.2.

For more information on this file, see
https://docs.djangoproject.com/en/1.11/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/1.11/ref/settings/
"""

import os
import environ

# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
from kombu import Queue, Exchange
from oscar import OSCAR_MAIN_TEMPLATE_DIR, get_core_apps
from oscar.defaults import *
from celery.schedules import crontab

BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))
ROOT_DIR = environ.Path(__file__) - 2  # (addwine/settings/base.py - 2 = addwine/)

# Load operating system environment variables and then prepare to use them
env = environ.Env()

# .env file, should load only in development environment
READ_DOT_ENV_FILE = env.bool('DJANGO_READ_DOT_ENV_FILE', default=True)

if READ_DOT_ENV_FILE:
    # Operating System Environment variables have precedence over variables defined in the .env file,
    # that is to say variables from the .env files will only be used if not defined
    # as environment variables.
    env_file = str(ROOT_DIR.path('.env'))
    # print('Loading : {}'.format(env_file))
    env.read_env(env_file)
    # print('The .env file has been loaded. See base.py for more information')


# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/1.11/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = env('SECRET_KEY')

# Application definition

oscar_apps = get_core_apps(['customer', 'voucher', 'catalogue', 'offer', 'basket',
                            'order', 'partner', 'shipping', 'payment', 'promotions', 'analytics', 'checkout', 'search'])
oscar_apps = list(filter(lambda app_name: 'dashboard' not in app_name, oscar_apps))

APPS = [
         'permissions',
         'feedback',
         'common',
         'site_configs',
         'ckeditor_customization',
         'marketing',
         'embed_video',
         'faq',
         'news',
         'sommeliers',
         'web',
         'gallery',
         'seo',
         'sommelier_bot',
         'amocrm_api',
         'unisender_api',
         'yandex_market',
         'products_editor',
         'recommendation_emails'
] + oscar_apps

INSTALLED_APPS = [
                     'dal',
                     'dal_select2',
                     'admin_tools',
                     'admin_tools.theming',
                     'admin_tools.menu',
                     'admin_tools.dashboard',
                     'django.contrib.auth',
                     'django.contrib.contenttypes',
                     'django.contrib.sessions',
                     'django.contrib.sites',
                     'django.contrib.messages',
                     'django.contrib.staticfiles',
                     'django.contrib.flatpages',
                     'django.contrib.admin',
                     'django.contrib.postgres',
                     'django.contrib.sitemaps',


                     'adminsortable2',
                     'ckeditor',
                     'ckeditor_uploader',
                     'compressor',
                     'widget_tweaks',
                     'el_pagination',
                     'sortedm2m',
                     'cacheops',
                     'django_celery_beat',
                     'django_celery_results',

                 ] + APPS

SITE_ID = 1

MIDDLEWARE_CLASSES = [
    'django.middleware.gzip.GZipMiddleware',
    #'common.middleware.ProfileMiddleware',
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    #'django.middleware.clickjacking.XFrameOptionsMiddleware',

    'common.middleware.TechWorksMiddleware',
    'oscar.apps.basket.middleware.BasketMiddleware',
    'django.contrib.flatpages.middleware.FlatpageFallbackMiddleware',
]

ROOT_URLCONF = 'addwine.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [
            os.path.join(BASE_DIR, 'templates'),
            os.path.join(BASE_DIR, 'web/templates/oscar'),
            OSCAR_MAIN_TEMPLATE_DIR
        ],
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.template.context_processors.i18n',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',

                'oscar.apps.search.context_processors.search_form',
                'oscar.apps.promotions.context_processors.promotions',
                'oscar.apps.checkout.context_processors.checkout',
                'oscar.apps.customer.notifications.context_processors.notifications',
                'oscar.core.context_processors.metadata',
            ],
            'loaders': [
                    'admin_tools.template_loaders.Loader',
                    'django.template.loaders.filesystem.Loader',
                    'django.template.loaders.app_directories.Loader',
            ]
        },
    },
]

# Cache settings
CACHES = {
    "default": {
        "BACKEND": "django_redis.cache.RedisCache",
        "LOCATION": env('REDIS_URL', default="redis://127.0.0.1:6379/1"),
        "OPTIONS": {
            "CLIENT_CLASS": "django_redis.client.DefaultClient"
        },
        "KEY_PREFIX": "addwine"
    }
}

SITE_CONFIGS_CACHE = 'default'

CACHE_TTL_FOREVER = 365 * 24 * 60 * 60 # 1 year
CACHE_TTL_LONG = 6 * 60 * 60  # 6 hours
CACHE_TTL_MEDIUM = 30 * 60  # 30 minutes
CACHE_TTL_SHORT = 15 * 60  # 15 minuets

CACHEOPS_REDIS = env('REDIS_URL', default="redis://127.0.0.1:6379/1")
CACHEOPS_DEFAULTS = {
    'timeout': CACHE_TTL_LONG
}
CACHEOPS = {
    'catalogue.category': {'ops': {}},
    'catalogue.productimage': {'ops': 'all'},
    'catalogue.productattribute': {'ops': 'all'},
    'catalogue.productattributevalue': {'ops': {}},
    'catalogue.brand': {'ops': {}},

    'offer.rangediscount': {'ops': {}},
    'offer.range': {'ops': {}},

    'partner.stockrecord': {'ops': 'all'},
    'news.*': {'ops': 'all'},
    'common.*': {'ops': {}},
    'faq.*': {'ops': {}},
    'shipping.*': {'ops': {}},

    'payment.paymentmethod': {'ops': 'all'},
}

AUTH_USER_MODEL = 'customer.User'
OSCAR_HIDDEN_FEATURES = ['reviews', 'wishlists']
OSCAR_DEFAULT_CURRENCY = "руб."
OSCAR_PRODUCT_SEARCH_HANDLER = 'catalogue.custom_search_handler.CustomProductSearchHandler'
OSCAR_DISCOUNTS_IMAGE_FOLDER = 'images/discounts/'

BOTTOM_DISCOUNTS_COUNT = 5
BOTTOM_ARTICLES_COUNT = 5
POPULAR_ARTICLES_COUNT = 10
POPULAR_PRODUCTS_COUNT = 10
BRAND_POPULAR_PRODUCTS_COUNT = 15
SOMMELIER_DISPLAY_COUNT = 15
OSCAR_PRODUCTS_PER_PAGE = 30
THUMBNAIL_PRESERVE_FORMAT = True
# THUMBNAIL_ENGINE = 'web.sorl_engines.ConverterEngine'
THUMBNAIL_KVSTORE = 'sorl.thumbnail.kvstores.redis_kvstore.KVStore'

HAYSTACK_CONNECTIONS = {
    'default': {
        'ENGINE': 'search.elasticsearch2_backend.Elasticsearch2SearchEngine',
        'URL': env('ELASTICSEARCH_URL', default='http://127.0.0.1:9200/'),
        'INDEX_NAME': 'haystack',
    },
}
HAYSTACK_SIGNAL_PROCESSOR = 'haystack.signals.RealtimeSignalProcessor'
HAYSTACK_TASK_CONFIG = {
}

SEARCH_RANGES = OrderedDict([
        ('price', {'name': 'Цена', 'field': 'price'}),
])

OSCAR_SEARCH_FACETS = {
    'fields': OrderedDict([
        ('product_class', {'name': 'Товар', 'field': 'product_class',
                           'model': 'catalogue.ProductClass', 'use_and_rule': False}),
        ('brand', {'name': 'Бренд', 'field': 'brand',
                   'model': 'catalogue.Brand', 'use_and_rule': False}),
    ]),
    'queries': OrderedDict(),
}

OSCAR_ALLOW_ANON_CHECKOUT = True

# Yandex market configs

YANDEX_MARKET_TASK_CONFIG = {
}
YANDEX_MARKET_ENABLED = False

GOOGLE_MERCHANT_ENABLED = False

# Catalogue rating configs

CATALOGUE_RATING_TASK_CONFIG = {
}

# Catalogue discounts update configs

CATALOGUE_DISCOUNTS_TASK_CONFIG = {
}

# AmoCRM configs

AMOCRM_USER_LOGIN = 'i9099198818@gmail.com'
AMOCRM_API_KEY = env('AMOCRM_API_KEY', default='')
# AMOCRM_HOST_NAME = '0.0.0.0'
AMOCRM_HOST_NAME = 'justaddwine'
AMOCRM_SYNC_ENABLED = False

# Moysklad config
MOYSKLAD_DOMAIN = 'online.moysklad.ru'
MOYSKLAD_LOGIN = env('MOYSKLAD_LOGIN', default='')
MOYSKLAD_PASSWORD = env('MOYSKLAD_PASSWORD', default='')

# UniSender

UNISENDER_TASK_CONFIG = {
}

UNISENDER_API_KEY = env('UNISENDER_API_KEY', default='')
UNISENDER_EMAIL_LIST_ID = 11915981
UNISENDER_CONTACTS_EXPORT_LIMIT = 1000
UNISENDER_CONTACTS_EXPORT_SYNC_LIMIT = 10000
UNISENDER_SYNC_ENABLED = False


GOOGLE_RECAPTCHA_SECRET_KEY = '6LfRYF4UAAAAAIgOHD7PHp97mYejinDTkxhy8iko'


WSGI_APPLICATION = 'addwine.wsgi.application'

# CKEditor configs

CKEDITOR_UPLOAD_PATH = 'ckeditor/'

CKEDITOR_CONFIGS = {
    'default': {
        'enterMode': 2,
        'toolbar': 'Custom',
        'extraPlugins': 'image2,youtube',
        'removeDialogTabs': 'link:advanced',
        'extraAllowedContent': 'a(*)',
        'toolbar_Custom': [
            ['Source', 'Cut', 'Copy', 'Paste', 'PasteText', 'PasteFromWord', ],
            ['Undo', 'Redo', '-', 'SelectAll', 'RemoveFormat'],
            ['Styles', 'Format', 'FontSize'],
            ['Subscript', 'Superscript', 'TextColor'],
            ['Bold', 'Italic', 'Underline', 'Strike'],
            ['JustifyLeft', 'JustifyCenter', 'JustifyRight', 'JustifyBlock'],
            ['Link', 'Unlink', 'Anchor', 'SpecialChar'],
            ['Image', 'Youtube']
        ],
        'format_tags': 'p;h2;h3;h4',
    }
}


# Password validation
# https://docs.djangoproject.com/en/1.11/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]

ADMINS = (('Илья Шмелев', 'netral23@yandex.ru'),)

# Sommelier
SOMMELIER_GROUP_NAME = 'Сомелье'

# Products editor
PRODUCTS_EDITOR_GROUP_NAME = 'Редактор товаров'

# Permissions configs
PERMISSIONS = {
    'sommeliertask': 'acd',
    'sommeliertasksubmited': 'acd',
    'productseditorproduct': 'acd'
}

# News configs

NEWS_RATING_COOKIE_KEY = "news_voted_articles"

# Internationalization
# https://docs.djangoproject.com/en/1.11/topics/i18n/

LOCALE_PATHS = [
    os.path.join(os.path.dirname(BASE_DIR), 'locale')
]

LANGUAGE_CODE = 'ru-ru'
PHONENUMBER_DEFAULT_REGION = 'RU'
TIME_ZONE = 'Europe/Moscow'

USE_I18N = True

USE_L10N = True

USE_TZ = True

# Admin tools settings

ADMIN_TOOLS_MENU = 'addwine.menu.CustomMenu'
ADMIN_TOOLS_INDEX_DASHBOARD = 'addwine.dashboard.CustomIndexDashboard'
ADMIN_TOOLS_APP_INDEX_DASHBOARD = 'addwine.dashboard.CustomAppIndexDashboard'
ADMIN_TOOLS_THEMING_CSS = 'common/css/admin-style.css'


# Celery configs
CELERYD_HIJACK_ROOT_LOGGER = False
CELERY_TIMEZONE = TIME_ZONE
CELERY_BEAT_SCHEDULE = {
    'catalogue-decrease-rating': {
        'task': 'catalogue_rating.update',
        'schedule': crontab(minute=59, hour=23)
    },
    'recommendation-email-send-task': {
        'task': 'recommendation_emails.tasks.send_recommendation_emails',
        'schedule': crontab(minute=10, hour=8)
    },
    'catalogue-pull-moysklad': {
        'task': 'catalogue.tasks.pull_moisklad_assortiment',
        'schedule': 1*60*60  # every hour
    }
}
CELERY_BROKER_URL = ''

CELERY_RESULT_BACKEND = 'django-db'
CELERY_BEAT_SCHEDULER = 'django_celery_beat.schedulers:DatabaseScheduler'

CELERY_QUEUES = (
    Queue('high', Exchange('high'), routing_key='high'),
    Queue('normal', Exchange('normal'), routing_key='normal'),
    Queue('low', Exchange('low'), routing_key='low'),
)

CELERY_DEFAULT_QUEUE = 'normal'
CELERY_DEFAULT_EXCHANGE = 'normal'
CELERY_DEFAULT_ROUTING_KEY = 'normal'

CELERY_ROUTES = {
    # -- HIGH PRIORITY QUEUE -- #
    'amocrm.*': {'queue': 'high', 'routing_key': 'high'},
    # -- LOW PRIORITY QUEUE -- #
    'catalogue_rating.update': {'queue': 'low'},
    'search.update_index': {'queue': 'low'},
    'catalogue.tasks.pull_moisklad_assortiment': {'queue': 'low'},
}

# Keep result only if you really need them: CELERY_IGNORE_RESULT = False
# In all other cases it is better to have place somewhere in db
CELERY_IGNORE_RESULT = True

CELERY_ALWAYS_EAGER = False
CELERY_EAGER_PROPAGATES_EXCEPTIONS = False

# Django celery email
CELERY_EMAIL_CHUNK_SIZE = 4
CELERY_EMAIL_TASK_CONFIG = {
    'rate_limit': '1/s',  # * CELERY_EMAIL_CHUNK_SIZE
}

EMAIL_HOST = 'smtp.timeweb.ru'
EMAIL_PORT = '465'
EMAIL_HOST_USER = 'informer@addwine.ru'
EMAIL_HOST_PASSWORD = env('EMAIL_HOST_PASSWORD')
EMAIL_USE_SSL = True

# Recommendation Emails settings
SEND_RECOMMENDATION_EMAILS = True


WINELEVEL_EXPORT_IS_ENABLED = env.bool('WINELEVEL_EXPORT_IS_ENABLED', default=False)
WINELEVEL_EXPORT_URL = env('WINELEVEL_EXPORT_URL', default=None)

# Feedback configs
FEEDBACK_FROM = 'AddWine<' + EMAIL_HOST_USER + ">"
FEEDBACK_TASK_CONFIG = {
}

# Shipping settings
DADATA_TOKEN = env('DADATA_TOKEN')

# Telegram Bot settings
TELEGRAM_BOT_TOKEN = env('TELEGRAM_BOT_TOKEN')
TELEGRAM_BOT_TASK_CONFIG_API_TASK = {
}
TELEGRAM_BOT_TASK_CONFIG_NON_API_TASK = {
}

# TechWorksMiddleware config
TECHWORKS_ALLOWED_URLS = [
    '/utils/sommelier_bot/webhook/446229474:AAHXlHFdNlbZamhEPnVSxnUhQ6_5GhywS1U',
    '/utils/amocrm_api/webhook/LkXbeFn5Mqo7BeaE'
]

# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/1.11/howto/static-files/

STATICFILES_FINDERS = [
    'django.contrib.staticfiles.finders.FileSystemFinder',
    'django.contrib.staticfiles.finders.AppDirectoriesFinder',
    'compressor.finders.CompressorFinder'
]

STATIC_URL = '/static/'
MEDIA_URL = '/media/'
STATIC_ROOT = os.path.join(BASE_DIR, 'static')
MEDIA_ROOT = os.path.join(BASE_DIR, 'media')

PROJECT_LOGS_DIR = os.path.join(os.path.dirname(BASE_DIR), 'logs')


LOGGER_APP_CONFIG = {
    'handlers': ['project'],
    'level': 'INFO',
}

LOGGING_FORMAT = env('LOGGING_FORMAT', default='file')


def file_handler_ops(file_name):
    return {
        'class': 'logging.handlers.RotatingFileHandler',
        'filename': os.path.join(PROJECT_LOGS_DIR, file_name),
        'backupCount': 3,
        'maxBytes': 15 * 1024 * 1024  # 15 Mb
    }


def console_handler_ops(_):
    return {
        'class': 'logging.StreamHandler',
    }


if LOGGING_FORMAT == 'file':
    LOGGING_HANDLER_FORMAT_GENERATE = file_handler_ops
else:
    LOGGING_HANDLER_FORMAT_GENERATE = console_handler_ops


LOGGING = {
    'version': 1,
    'disable_existing_loggers': False,
    'filters': {
        'require_debug_false': {
            '()': 'django.utils.log.RequireDebugFalse'
        }
    },
    'formatters': {
        'default': {
            'format': '[%(levelname)s: %(asctime)s] %(name)s.%(funcName)s:%(levelno)s\nMessage: %(message)s',
            'datefmt': "%d.%m.%Y %H:%M:%S"
        },
    },
    'handlers': {
        'mail_admins': {
            'level': 'ERROR',
            'filters': ['require_debug_false'],
            'class': 'django.utils.log.AdminEmailHandler'
        },
        'telegram_bot': {
            'level': 'WARNING',
            'formatter': 'default',
            **LOGGING_HANDLER_FORMAT_GENERATE('telegram_bot.log')
        },
        'amocrm': {
            'level': 'INFO',
            'formatter': 'default',
            **LOGGING_HANDLER_FORMAT_GENERATE('amocrm.log')
        },
        'unisender': {
            'level': 'INFO',
            'formatter': 'default',
            **LOGGING_HANDLER_FORMAT_GENERATE('unisender.log')
        },
        'celery': {
            'level': 'INFO',
            'formatter': 'default',
            'class': 'logging.StreamHandler',
        },
        'project': {
            'level': 'DEBUG',
            'formatter': 'default',
            **LOGGING_HANDLER_FORMAT_GENERATE('project.log')
        },
        'errors': {
            'level': 'ERROR',
            'formatter': 'default',
            **LOGGING_HANDLER_FORMAT_GENERATE('errors.log')
        },
        'doc_import': {
            'level': 'INFO',
            'formatter': 'default',
            **LOGGING_HANDLER_FORMAT_GENERATE('doc_import.log')
        }
    },
    'loggers': {
        'django.request': {
            'handlers': ['mail_admins'],
            'level': 'ERROR',
            'propagate': True,
        },
        'django': {
            'handlers': ['errors'],
            'level': 'ERROR'
        },
        'telegram': {
            'handlers': ['telegram_bot'],
            'level': 'WARNING'
        },
        'search.tasks':  {
            'handlers': ['project'],
            'level': 'INFO'
        },
        'sommelier_bot.tasks':  {
            'handlers': ['project'],
            'level': 'INFO'
        },
        'amocrm_api':  {
            'handlers': ['amocrm'],
            'level': 'INFO'
        },
        'unisender_api':  {
            'handlers': ['unisender'],
            'level': 'INFO'
        },
        'catalogue.doc_import':  {
            'handlers': ['doc_import'],
            'level': 'INFO'
        },
    },
}

LOGGING['loggers'].update({
    app_name: LOGGER_APP_CONFIG for app_name in APPS
})

REST_FRAMEWORK = {
    'DEFAULT_AUTHENTICATION_CLASSES': (
        'rest_framework.authentication.TokenAuthentication',
    ),
    'DEFAULT_PERMISSION_CLASSES': (
        'rest_framework.permissions.AllowAny',
    ),
}